> For the complete documentation index, see [llms.txt](https://docs.flowretail.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flowretail.com/docs/developers/api-documentation/campaign/set-selections-on-a-campaign.md).

# Set selections on a campaign

Set selections on a campaign

Required permissions: CAMPAIGN

```json
{"openapi":"3.0.2","info":{"title":"Flow Retail API version 2","version":"2.0.0"},"tags":[{"name":"Campaign","description":"Campaign"}],"servers":[{"description":"Flow Retail Production","url":"https://api.flowretail.com/v2"},{"description":"Flow Retail Stage","url":"https://api.stage.flowretail.com/v2"}],"security":[{"accessToken":[]},{"authToken":[]},{"integrationToken":[]}],"components":{"securitySchemes":{"accessToken":{"description":"Access token recevied after user login with a deviceToken","scheme":"bearer","type":"http"},"authToken":{"description":"Token received from the auth service","scheme":"bearer","type":"http"},"integrationToken":{"scheme":"bearer","type":"http"}},"responses":{"CampaignResponse":{"description":"Example response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CampaignResponseSchema"}}}}},"schemas":{"CampaignResponseSchema":{"title":"CampaignResponseSchema","type":"object","required":["name","status","displayName","validFrom","validTo","type","discountType","selection","quantityThreshold","amountThreshold","discountAmount","discountPercent","maxUsage","priority","pricelist","stores","campaignUid","campaignCode","preventCombinations","customerGroup"],"properties":{"name":{"type":"string"},"status":{"$ref":"#/components/schemas/CampaignStatusENUM"},"displayName":{"type":"string"},"validFrom":{"type":"string","format":"date-time"},"validTo":{"type":"string","format":"date-time"},"type":{"$ref":"#/components/schemas/CampaignTypeENUM"},"discountType":{"$ref":"#/components/schemas/CampaignDiscountTypeENUM"},"selection":{"$ref":"#/components/schemas/CampaignSelectionResponseSchema"},"quantityThreshold":{"type":"integer"},"amountThreshold":{"type":"integer"},"discountAmount":{"type":"integer"},"discountPercent":{"type":"integer"},"maxUsage":{"type":"integer"},"priority":{"type":"integer"},"pricelist":{"$ref":"#/components/schemas/CampaignPricelistSchema"},"stores":{"type":"array","items":{"$ref":"#/components/schemas/CampaignStoreSchema"}},"campaignUid":{"$ref":"#/components/schemas/UID"},"campaignCode":{"type":"string"},"preventCombinations":{"type":"boolean"},"customerGroup":{"$ref":"#/components/schemas/CampaignCustomerGroupSchema"}}},"CampaignStatusENUM":{"title":"CampaignStatusENUM","description":"|ENUM      | Description |\n| ---------------- | ------------ |\n| NEW | Campaign is in a modeling state. Can be modified|\n| ACTIVE | Campaign is active, and is considered when making sales operations. Campaign can not be modified|\n| CLOSED | Campaign is closed.|","enum":["NEW","ACTIVE","CLOSED"],"type":"string"},"CampaignTypeENUM":{"title":"CampaignTypeENUM","description":"|ENUM      | Description |\n| ---------------- | ------------ |\n| CAMPAIGN | Normal campaign with rules set|\n| PRICELIST | A campaign that includes a pricelist. No rules applies|","enum":["CAMPAIGN","PRICELIST"],"type":"string"},"CampaignDiscountTypeENUM":{"title":"CampaignDiscountTypeENUM","description":"|ENUM      | Description |\n| ---------------- | ------------ |\n| CHEAPEST_PRODUCT | Cheapest product will be discounted|\n| QUALIFIED_PRODUCT | All qualified products will be discounted|\n| ORDER_DISCOUNT | An order discount will be added to the order|","enum":["CHEAPEST_PRODUCT","QUALIFIED_PRODUCT","ORDER_DISCOUNT"],"type":"string"},"CampaignSelectionResponseSchema":{"title":"CampaignSelectionResponseSchema","type":"object","description":"Ths section contains all selections done on a campaign","required":["include","exclude"],"properties":{"include":{"$ref":"#/components/schemas/CampaignProductSelectionResponseSchema"},"exclude":{"$ref":"#/components/schemas/CampaignProductSelectionResponseSchema"}}},"CampaignProductSelectionResponseSchema":{"title":"CampaignSelectionResponseSchema","type":"object","description":"Ths section contains all selections done on a campaign","required":["productGroups:","brands","categories","products"],"properties":{"productGroups:":{"type":"array","items":{"$ref":"#/components/schemas/CampaignProductGroupSchema"}},"brands":{"type":"array","items":{"$ref":"#/components/schemas/CampaignBrandSchema"}},"categories":{"type":"array","items":{"$ref":"#/components/schemas/CampaignCategorySchema"}},"products":{"type":"array","items":{"$ref":"#/components/schemas/CampaignProductSchema"}}}},"CampaignProductGroupSchema":{"title":"CampaignProductGroupSchema","type":"object","required":["productGroupUid","name"],"properties":{"productGroupUid":{"$ref":"#/components/schemas/UID"},"name":{"type":"string"}},"description":"This section contains all product groups included in a campaign"},"UID":{"title":"UID","type":"string","pattern":"^[A-Za-z0-9-_]+"},"CampaignBrandSchema":{"title":"CampaignBrandSchema","type":"object","required":["brandUid","name"],"properties":{"brandUid":{"$ref":"#/components/schemas/UID"},"name":{"type":"string"}},"description":"This section contains all brands included in a campaign"},"CampaignCategorySchema":{"title":"CampaignCategorySchema","type":"object","description":"This section contains all brands included in a campaign","required":["categoryUid","name"],"properties":{"categoryUid":{"$ref":"#/components/schemas/UID"},"name":{"type":"string"}}},"CampaignProductSchema":{"title":"CampaignProductSchema","type":"object","required":["productUid","name","sku"],"properties":{"productUid":{"$ref":"#/components/schemas/UID"},"name":{"type":"string"},"sku":{"type":"string"}},"description":"This section contains all individual products included or excluded in a campaign"},"CampaignPricelistSchema":{"title":"CampaignPricelistSchema","type":"object","required":["pricelistUid","name"],"properties":{"pricelistUid":{"$ref":"#/components/schemas/UID"},"name":{"type":"string"}},"description":"This section contains the pricelist included in a campaign"},"CampaignStoreSchema":{"title":"CampaignStoreSchema","type":"object","required":["storeUid","name"],"properties":{"storeUid":{"$ref":"#/components/schemas/UID"},"name":{"type":"string"}},"description":"This section contains all stores included in a campaign"},"CampaignCustomerGroupSchema":{"title":"CampaignCustomerGroupSchema","type":"object","description":"This section contains all stores included in a campaign","nullable":true,"required":["customerGroupUid","name"],"properties":{"customerGroupUid":{"$ref":"#/components/schemas/UID"},"name":{"type":"string"}}},"CampaignSelectionRequestSchema":{"title":"CampaignSelectionRequestSchema","type":"object","description":"This request has 3 sections:\n\ncreate: A selection to create in the campaign\ndelete: A selection to delete from campaign.","properties":{"create":{"$ref":"#/components/schemas/CampaignProductSelectionRequestSchema"},"delete":{"$ref":"#/components/schemas/CampaignProductSelectionRequestSchema"}}},"CampaignProductSelectionRequestSchema":{"title":"CampaignProductSelectionRequestSchema","type":"object","description":"This request contains a selection of product groups, brands and exact productUids to include or exclude in a campaign.\n","properties":{"include":{"$ref":"#/components/schemas/CampaignProductSelectionSchema"},"exclude":{"$ref":"#/components/schemas/CampaignProductSelectionSchema"}}},"CampaignProductSelectionSchema":{"title":"CampaignProductSelectionSchema","type":"object","description":"This section contains all selections done on a campaign","properties":{"productGroupUids":{"type":"array","items":{"$ref":"#/components/schemas/UID"}},"brandUids":{"type":"array","items":{"$ref":"#/components/schemas/UID"}},"categoryUids":{"type":"array","items":{"$ref":"#/components/schemas/UID"}},"productUids":{"type":"array","items":{"$ref":"#/components/schemas/UID"}}}}},"requestBodies":{"CampaignSelectionRequest":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CampaignSelectionRequestSchema"}}}}}},"paths":{"/tenants/{tenantUid}/campaigns/{campaignUid}/selections":{"post":{"summary":"Set selections on a campaign","tags":["Campaign"],"responses":{"200":{"$ref":"#/components/responses/CampaignResponse"}},"operationId":"set-campaign-selections","description":"Set selections on a campaign\n\nRequired permissions: CAMPAIGN","requestBody":{"$ref":"#/components/requestBodies/CampaignSelectionRequest"}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.flowretail.com/docs/developers/api-documentation/campaign/set-selections-on-a-campaign.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
